/* ConfigWidget.c generated by valac 0.12.1, the Vala compiler
 * generated from ConfigWidget.vala, do not modify */

/* -*- Mode: Vala; indent-tabs-mode: nil; tab-width: 2 -*- */
/*
    This file is part of Déjà Dup.
    © 2008–2010 Michael Terry <mike@mterry.name>

    Déjà Dup is free software: you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation, either version 3 of the License, or
    (at your option) any later version.

    Déjà Dup is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with Déjà Dup.  If not, see <http://www.gnu.org/licenses/>.
*/

#include <glib.h>
#include <glib-object.h>
#include <gtk/gtk.h>
#include <gio/gio.h>
#include <common.h>
#include <stdlib.h>
#include <string.h>


#define DEJA_DUP_TYPE_CONFIG_WIDGET (deja_dup_config_widget_get_type ())
#define DEJA_DUP_CONFIG_WIDGET(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), DEJA_DUP_TYPE_CONFIG_WIDGET, DejaDupConfigWidget))
#define DEJA_DUP_CONFIG_WIDGET_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), DEJA_DUP_TYPE_CONFIG_WIDGET, DejaDupConfigWidgetClass))
#define DEJA_DUP_IS_CONFIG_WIDGET(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), DEJA_DUP_TYPE_CONFIG_WIDGET))
#define DEJA_DUP_IS_CONFIG_WIDGET_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), DEJA_DUP_TYPE_CONFIG_WIDGET))
#define DEJA_DUP_CONFIG_WIDGET_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), DEJA_DUP_TYPE_CONFIG_WIDGET, DejaDupConfigWidgetClass))

typedef struct _DejaDupConfigWidget DejaDupConfigWidget;
typedef struct _DejaDupConfigWidgetClass DejaDupConfigWidgetClass;
typedef struct _DejaDupConfigWidgetPrivate DejaDupConfigWidgetPrivate;
#define _g_object_unref0(var) ((var == NULL) ? NULL : (var = (g_object_unref (var), NULL)))
#define _g_free0(var) (var = (g_free (var), NULL))

struct _DejaDupConfigWidget {
	GtkEventBox parent_instance;
	DejaDupConfigWidgetPrivate * priv;
	DejaDupSimpleSettings* settings;
};

struct _DejaDupConfigWidgetClass {
	GtkEventBoxClass parent_class;
	void (*set_from_config) (DejaDupConfigWidget* self, GAsyncReadyCallback _callback_, gpointer _user_data_);
	void (*set_from_config_finish) (DejaDupConfigWidget* self, GAsyncResult* _res_);
};

struct _DejaDupConfigWidgetPrivate {
	GtkWidget* _mnemonic_widget;
	gchar* _key;
	gchar* _ns;
};


static gpointer deja_dup_config_widget_parent_class = NULL;

GType deja_dup_config_widget_get_type (void) G_GNUC_CONST;
#define DEJA_DUP_CONFIG_WIDGET_GET_PRIVATE(o) (G_TYPE_INSTANCE_GET_PRIVATE ((o), DEJA_DUP_TYPE_CONFIG_WIDGET, DejaDupConfigWidgetPrivate))
enum  {
	DEJA_DUP_CONFIG_WIDGET_DUMMY_PROPERTY,
	DEJA_DUP_CONFIG_WIDGET_MNEMONIC_WIDGET,
	DEJA_DUP_CONFIG_WIDGET_KEY,
	DEJA_DUP_CONFIG_WIDGET_NS
};
void deja_dup_config_widget_watch_key (DejaDupConfigWidget* self, const gchar* key, GSettings* s);
static gboolean deja_dup_config_widget_key_changed_wrapper (DejaDupConfigWidget* w);
static void deja_dup_config_widget_key_changed (DejaDupConfigWidget* self);
void deja_dup_config_widget_set_from_config (DejaDupConfigWidget* self, GAsyncReadyCallback _callback_, gpointer _user_data_);
void deja_dup_config_widget_set_from_config_finish (DejaDupConfigWidget* self, GAsyncResult* _res_);
static gboolean deja_dup_config_widget_on_mnemonic_activate (DejaDupConfigWidget* self, GtkWidget* w, gboolean g);
GtkWidget* deja_dup_config_widget_get_mnemonic_widget (DejaDupConfigWidget* self);
DejaDupConfigWidget* deja_dup_config_widget_construct (GType object_type);
void deja_dup_config_widget_set_mnemonic_widget (DejaDupConfigWidget* self, GtkWidget* value);
const gchar* deja_dup_config_widget_get_key (DejaDupConfigWidget* self);
static void deja_dup_config_widget_set_key (DejaDupConfigWidget* self, const gchar* value);
const gchar* deja_dup_config_widget_get_ns (DejaDupConfigWidget* self);
static void deja_dup_config_widget_set_ns (DejaDupConfigWidget* self, const gchar* value);
static GObject * deja_dup_config_widget_constructor (GType type, guint n_construct_properties, GObjectConstructParam * construct_properties);
static gboolean _deja_dup_config_widget_on_mnemonic_activate_gtk_widget_mnemonic_activate (GtkWidget* _sender, gboolean group_cycling, gpointer self);
static void deja_dup_config_widget_finalize (GObject* obj);
static void _vala_deja_dup_config_widget_get_property (GObject * object, guint property_id, GValue * value, GParamSpec * pspec);
static void _vala_deja_dup_config_widget_set_property (GObject * object, guint property_id, const GValue * value, GParamSpec * pspec);


void deja_dup_config_widget_watch_key (DejaDupConfigWidget* self, const gchar* key, GSettings* s) {
	gchar* _tmp0_ = NULL;
	gchar* _tmp3_;
	gchar* signal_name;
	g_return_if_fail (self != NULL);
	if (s == NULL) {
		s = (GSettings*) self->settings;
	}
	if (key == NULL) {
		gchar* _tmp1_;
		_tmp1_ = g_strdup ("change-event");
		_g_free0 (_tmp0_);
		_tmp0_ = _tmp1_;
	} else {
		gchar* _tmp2_ = NULL;
		_tmp2_ = g_strdup_printf ("changed::%s", key);
		_g_free0 (_tmp0_);
		_tmp0_ = _tmp2_;
	}
	_tmp3_ = g_strdup (_tmp0_);
	signal_name = _tmp3_;
	g_signal_connect_swapped (s, signal_name, (GCallback) deja_dup_config_widget_key_changed_wrapper, self);
	_g_free0 (signal_name);
	_g_free0 (_tmp0_);
}


static gboolean deja_dup_config_widget_key_changed_wrapper (DejaDupConfigWidget* w) {
	gboolean result = FALSE;
	g_return_val_if_fail (w != NULL, FALSE);
	deja_dup_config_widget_key_changed (w);
	result = FALSE;
	return result;
}


static void deja_dup_config_widget_key_changed (DejaDupConfigWidget* self) {
	g_return_if_fail (self != NULL);
	deja_dup_config_widget_set_from_config (self, NULL, NULL);
	g_signal_emit_by_name (self, "changed");
}


void deja_dup_config_widget_set_from_config (DejaDupConfigWidget* self, GAsyncReadyCallback _callback_, gpointer _user_data_) {
	DEJA_DUP_CONFIG_WIDGET_GET_CLASS (self)->set_from_config (self, _callback_, _user_data_);
}


void deja_dup_config_widget_set_from_config_finish (DejaDupConfigWidget* self, GAsyncResult* _res_) {
	DEJA_DUP_CONFIG_WIDGET_GET_CLASS (self)->set_from_config_finish (self, _res_);
}


static gboolean deja_dup_config_widget_on_mnemonic_activate (DejaDupConfigWidget* self, GtkWidget* w, gboolean g) {
	gboolean result = FALSE;
	g_return_val_if_fail (self != NULL, FALSE);
	g_return_val_if_fail (w != NULL, FALSE);
	if (self->priv->_mnemonic_widget != NULL) {
		gboolean _tmp0_;
		_tmp0_ = gtk_widget_mnemonic_activate (self->priv->_mnemonic_widget, g);
		result = _tmp0_;
		return result;
	} else {
		result = FALSE;
		return result;
	}
}


DejaDupConfigWidget* deja_dup_config_widget_construct (GType object_type) {
	DejaDupConfigWidget * self = NULL;
	self = (DejaDupConfigWidget*) g_object_new (object_type, NULL);
	return self;
}


GtkWidget* deja_dup_config_widget_get_mnemonic_widget (DejaDupConfigWidget* self) {
	GtkWidget* result;
	g_return_val_if_fail (self != NULL, NULL);
	result = self->priv->_mnemonic_widget;
	return result;
}


static gpointer _g_object_ref0 (gpointer self) {
	return self ? g_object_ref (self) : NULL;
}


void deja_dup_config_widget_set_mnemonic_widget (DejaDupConfigWidget* self, GtkWidget* value) {
	GtkWidget* _tmp0_;
	g_return_if_fail (self != NULL);
	_tmp0_ = _g_object_ref0 (value);
	_g_object_unref0 (self->priv->_mnemonic_widget);
	self->priv->_mnemonic_widget = _tmp0_;
	g_object_notify ((GObject *) self, "mnemonic-widget");
}


const gchar* deja_dup_config_widget_get_key (DejaDupConfigWidget* self) {
	const gchar* result;
	g_return_val_if_fail (self != NULL, NULL);
	result = self->priv->_key;
	return result;
}


static void deja_dup_config_widget_set_key (DejaDupConfigWidget* self, const gchar* value) {
	gchar* _tmp0_;
	g_return_if_fail (self != NULL);
	_tmp0_ = g_strdup (value);
	_g_free0 (self->priv->_key);
	self->priv->_key = _tmp0_;
	g_object_notify ((GObject *) self, "key");
}


const gchar* deja_dup_config_widget_get_ns (DejaDupConfigWidget* self) {
	const gchar* result;
	g_return_val_if_fail (self != NULL, NULL);
	result = self->priv->_ns;
	return result;
}


static void deja_dup_config_widget_set_ns (DejaDupConfigWidget* self, const gchar* value) {
	gchar* _tmp0_;
	g_return_if_fail (self != NULL);
	_tmp0_ = g_strdup (value);
	_g_free0 (self->priv->_ns);
	self->priv->_ns = _tmp0_;
	g_object_notify ((GObject *) self, "ns");
}


static gboolean _deja_dup_config_widget_on_mnemonic_activate_gtk_widget_mnemonic_activate (GtkWidget* _sender, gboolean group_cycling, gpointer self) {
	gboolean result;
	result = deja_dup_config_widget_on_mnemonic_activate (self, _sender, group_cycling);
	return result;
}


static GObject * deja_dup_config_widget_constructor (GType type, guint n_construct_properties, GObjectConstructParam * construct_properties) {
	GObject * obj;
	GObjectClass * parent_class;
	DejaDupConfigWidget * self;
	DejaDupSimpleSettings* _tmp0_ = NULL;
	parent_class = G_OBJECT_CLASS (deja_dup_config_widget_parent_class);
	obj = parent_class->constructor (type, n_construct_properties, construct_properties);
	self = DEJA_DUP_CONFIG_WIDGET (obj);
	_tmp0_ = deja_dup_get_settings (self->priv->_ns);
	_g_object_unref0 (self->settings);
	self->settings = _tmp0_;
	if (self->priv->_key != NULL) {
		deja_dup_config_widget_watch_key (self, self->priv->_key, NULL);
	}
	g_signal_connect_object ((GtkWidget*) self, "mnemonic-activate", (GCallback) _deja_dup_config_widget_on_mnemonic_activate_gtk_widget_mnemonic_activate, self, 0);
	return obj;
}


static void deja_dup_config_widget_class_init (DejaDupConfigWidgetClass * klass) {
	deja_dup_config_widget_parent_class = g_type_class_peek_parent (klass);
	g_type_class_add_private (klass, sizeof (DejaDupConfigWidgetPrivate));
	G_OBJECT_CLASS (klass)->get_property = _vala_deja_dup_config_widget_get_property;
	G_OBJECT_CLASS (klass)->set_property = _vala_deja_dup_config_widget_set_property;
	G_OBJECT_CLASS (klass)->constructor = deja_dup_config_widget_constructor;
	G_OBJECT_CLASS (klass)->finalize = deja_dup_config_widget_finalize;
	g_object_class_install_property (G_OBJECT_CLASS (klass), DEJA_DUP_CONFIG_WIDGET_MNEMONIC_WIDGET, g_param_spec_object ("mnemonic-widget", "mnemonic-widget", "mnemonic-widget", GTK_TYPE_WIDGET, G_PARAM_STATIC_NAME | G_PARAM_STATIC_NICK | G_PARAM_STATIC_BLURB | G_PARAM_READABLE | G_PARAM_WRITABLE));
	g_object_class_install_property (G_OBJECT_CLASS (klass), DEJA_DUP_CONFIG_WIDGET_KEY, g_param_spec_string ("key", "key", "key", NULL, G_PARAM_STATIC_NAME | G_PARAM_STATIC_NICK | G_PARAM_STATIC_BLURB | G_PARAM_READABLE | G_PARAM_WRITABLE | G_PARAM_CONSTRUCT_ONLY));
	g_object_class_install_property (G_OBJECT_CLASS (klass), DEJA_DUP_CONFIG_WIDGET_NS, g_param_spec_string ("ns", "ns", "ns", NULL, G_PARAM_STATIC_NAME | G_PARAM_STATIC_NICK | G_PARAM_STATIC_BLURB | G_PARAM_READABLE | G_PARAM_WRITABLE | G_PARAM_CONSTRUCT_ONLY));
	g_signal_new ("changed", DEJA_DUP_TYPE_CONFIG_WIDGET, G_SIGNAL_RUN_LAST, 0, NULL, NULL, g_cclosure_marshal_VOID__VOID, G_TYPE_NONE, 0);
}


static void deja_dup_config_widget_instance_init (DejaDupConfigWidget * self) {
	gchar* _tmp0_;
	self->priv = DEJA_DUP_CONFIG_WIDGET_GET_PRIVATE (self);
	_tmp0_ = g_strdup ("");
	self->priv->_ns = _tmp0_;
}


static void deja_dup_config_widget_finalize (GObject* obj) {
	DejaDupConfigWidget * self;
	self = DEJA_DUP_CONFIG_WIDGET (obj);
	_g_object_unref0 (self->priv->_mnemonic_widget);
	_g_free0 (self->priv->_key);
	_g_free0 (self->priv->_ns);
	_g_object_unref0 (self->settings);
	G_OBJECT_CLASS (deja_dup_config_widget_parent_class)->finalize (obj);
}


GType deja_dup_config_widget_get_type (void) {
	static volatile gsize deja_dup_config_widget_type_id__volatile = 0;
	if (g_once_init_enter (&deja_dup_config_widget_type_id__volatile)) {
		static const GTypeInfo g_define_type_info = { sizeof (DejaDupConfigWidgetClass), (GBaseInitFunc) NULL, (GBaseFinalizeFunc) NULL, (GClassInitFunc) deja_dup_config_widget_class_init, (GClassFinalizeFunc) NULL, NULL, sizeof (DejaDupConfigWidget), 0, (GInstanceInitFunc) deja_dup_config_widget_instance_init, NULL };
		GType deja_dup_config_widget_type_id;
		deja_dup_config_widget_type_id = g_type_register_static (GTK_TYPE_EVENT_BOX, "DejaDupConfigWidget", &g_define_type_info, G_TYPE_FLAG_ABSTRACT);
		g_once_init_leave (&deja_dup_config_widget_type_id__volatile, deja_dup_config_widget_type_id);
	}
	return deja_dup_config_widget_type_id__volatile;
}


static void _vala_deja_dup_config_widget_get_property (GObject * object, guint property_id, GValue * value, GParamSpec * pspec) {
	DejaDupConfigWidget * self;
	self = DEJA_DUP_CONFIG_WIDGET (object);
	switch (property_id) {
		case DEJA_DUP_CONFIG_WIDGET_MNEMONIC_WIDGET:
		g_value_set_object (value, deja_dup_config_widget_get_mnemonic_widget (self));
		break;
		case DEJA_DUP_CONFIG_WIDGET_KEY:
		g_value_set_string (value, deja_dup_config_widget_get_key (self));
		break;
		case DEJA_DUP_CONFIG_WIDGET_NS:
		g_value_set_string (value, deja_dup_config_widget_get_ns (self));
		break;
		default:
		G_OBJECT_WARN_INVALID_PROPERTY_ID (object, property_id, pspec);
		break;
	}
}


static void _vala_deja_dup_config_widget_set_property (GObject * object, guint property_id, const GValue * value, GParamSpec * pspec) {
	DejaDupConfigWidget * self;
	self = DEJA_DUP_CONFIG_WIDGET (object);
	switch (property_id) {
		case DEJA_DUP_CONFIG_WIDGET_MNEMONIC_WIDGET:
		deja_dup_config_widget_set_mnemonic_widget (self, g_value_get_object (value));
		break;
		case DEJA_DUP_CONFIG_WIDGET_KEY:
		deja_dup_config_widget_set_key (self, g_value_get_string (value));
		break;
		case DEJA_DUP_CONFIG_WIDGET_NS:
		deja_dup_config_widget_set_ns (self, g_value_get_string (value));
		break;
		default:
		G_OBJECT_WARN_INVALID_PROPERTY_ID (object, property_id, pspec);
		break;
	}
}



